/*
Date: 27.03.2012
Author: Iaroslav Tverdokhlib
Complexity: O(NlogN)
Score: 100
*/
#define _CRT_SECURE_NO_DEPRECATE
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <iostream>
#include <iterator>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <sstream>
#include <fstream>
#include <ctime>
#include <cstring>
#pragma comment(linker, "/STACK:66777216")
using namespace std;
#define pb push_back
#define ppb pop_back
#define pi 3.1415926535897932384626433832795028841971
#define mp make_pair
//#define x first
//#define y second
#define pii pair<int,int>
#define pdd pair<double,double>
#define INF 1000000000
#define FOR(i,a,b) for (int _n(b), i(a); i <= _n; i++)
#define FORD(i,a,b) for(int i=(a),_b=(b);i>=_b;i--)
#define all(c) (c).begin(), (c).end()
#define SORT(c) sort(all(c))
#define rep(i,n) FOR(i,1,(n))
#define rept(i,n) FOR(i,0,(n)-1)
#define L(s) (int)((s).size())
#define C(a) memset((a),0,sizeof(a))
#define VI vector <int>
#define ll long long

struct pnt {
	int x, y;
	pnt() : x(0), y(0) {}
	pnt(int _x, int _y) : x(_x), y(_y) {}
};
inline pnt operator -(const pnt &a, const pnt &b) {
	return pnt(a.x - b.x, a.y - b.y);
}
inline ll vec(const pnt &a, const pnt &b) {
	return (ll)a.x * b.y - (ll)a.y * b.x;
}

struct mem {
	int old_k, new_pos;
	ll old_s;
	pnt old_p;
	mem() : old_k(0), new_pos(0), old_s(0) {}
	mem(int _old_k, int _new_pos, ll _old_s, pnt _old_p) : old_k(_old_k), new_pos(_new_pos), old_s(_old_s), old_p(_old_p) {}
};
struct ConvexChain {
	pair<pnt, ll> st[100001];
	mem md[100001];
	int k, m;
	ConvexChain() : k(0), m(0) {}
	inline void reset() {
		k = m = 0;
	}
	inline void push(const pnt &p) {
		int l = 0, r = k;
		while (r - l > 1) {
			int xx = (r + l) / 2;
			if (vec(st[xx].first - st[xx - 1].first, p - st[xx - 1].first) >= 0) r = xx; else
			l = xx;
		}
		md[m++] = mem(k, r, st[r].second, st[r].first);
		k = r + 1;
		ll s = 0;
		if (r) s = st[r - 1].second + (ll)st[r - 1].first.x * p.y - (ll)st[r - 1].first.y * p.x;
		st[r] = mp(p, s);
	}
	inline void pop() {
		k = md[--m].old_k;
		st[md[m].new_pos] = mp(md[m].old_p, md[m].old_s);
	}
	inline ll get_s() {
		if (k < 3) return 0;
		ll ans = st[k - 1].second + (ll)st[k - 1].first.x * st[0].first.y - (ll)st[k - 1].first.y * st[0].first.x;
		if (ans < 0) ans = - ans;
		return ans;
	}
};
int a,b,c,d,i,j,n,m,k;
ConvexChain up, down;
int main() {
	freopen("convex.dat","r",stdin);
	freopen("convex.sol","w",stdout);
	
	scanf("%d", &n);
	ll s = 0;
	rept(i, n) {
		scanf("%d", &a);
		a = (a + s) % 2;
		if (a == 0) { 
			scanf("%d%d", &b, &c);
			int lx = -INF;
			if (k) lx = up.st[up.k - 1].first.x;
			b = lx + (s + b) % (2 * INF + 1);
			c = (c + s) % (2 * INF + 1) - INF;

			up.push(pnt(b, c));
			down.push(pnt(b, -c));
			++k;
		} else {
			scanf("%d%d", &b, &c);
			b = (b + c + s) % k + 1;
			rept(j, b) {
				up.pop(); down.pop();
				--k;
			}
		}

		s = up.get_s() + down.get_s();
		printf("%lld\n", s);
	}
}
