/*
Date: 27.03.2012
Author: Iaroslav Tverdokhlib
Complexity: O(N^2)
Score: 30
*/
#define _CRT_SECURE_NO_DEPRECATE
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <iostream>
#include <iterator>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <sstream>
#include <fstream>
#include <ctime>
#include <cstring>
#pragma comment(linker, "/STACK:66777216")
using namespace std;
#define pb push_back
#define ppb pop_back
#define pi 3.1415926535897932384626433832795028841971
#define mp make_pair
#define x first
#define y second
#define pii pair<int,int>
#define pdd pair<double,double>
#define INF 1000000000
#define FOR(i,a,b) for (int _n(b), i(a); i <= _n; i++)
#define FORD(i,a,b) for(int i=(a),_b=(b);i>=_b;i--)
#define all(c) (c).begin(), (c).end()
#define SORT(c) sort(all(c))
#define rep(i,n) FOR(i,1,(n))
#define rept(i,n) FOR(i,0,(n)-1)
#define L(s) (int)((s).size())
#define C(a) memset((a),0,sizeof(a))
#define VI vector <int>
#define ll long long

struct pnt {
	int x, y;
	pnt() : x(0), y(0) {}
	pnt(int _x, int _y) : x(_x), y(_y) {}
};
inline pnt operator -(const pnt &a, const pnt &b) {
	return pnt(a.x - b.x, a.y - b.y);
}
inline ll vec(const pnt &a, const pnt &b) {
	return (ll)a.x * b.y - (ll)a.y * b.x;
}
inline bool operator <(const pnt &a, const pnt &b) {
	if (a.x != b.x) return a.x < b.x; else
	return a.y < b.y;
}
int a,b,c,d,i,j,n,m,k;
pnt up[100001], down[100001];
inline bool cmp(const pnt &a, const pnt &b) {
	ll r = vec(a, b);
	if (r) return r > 0;
	return (ll)a.x * a.x + (ll)a.y * a.y < (ll)b.x * b.x + (ll)b.y * b.y;
}

pnt st[100001];
inline ll get_s(pnt *v, int n) {
	if (n < 3) return 0;
	int s = 0;
	st[s++] = v[0];
	rep(i, n - 1) {
		while (s > 1 && vec(st[s - 1] - st[s - 2], v[i] - st[s - 2]) <= 0) --s;
		st[s++] = v[i];
	}
	st[s++] = v[0];
	ll ans = 0;
	rept(i, s - 1) {
		ans += (ll)st[i].x * st[i + 1].y - (ll)st[i].y * st[i + 1].x;
	}
	if (ans < 0) ans = -ans;
	return ans;
}

int main() {
	freopen("convex.dat","r",stdin);
	freopen("convex.sol","w",stdout);
	scanf("%d", &n);
	k = 0;
	ll s = 0;
	rept(i, n) {
		scanf("%d", &a);
		a = (a + s) % 2;
		if (a == 0) {
			scanf("%d%d", &b, &c);
			int lx = -INF;
			if (k) lx = up[k - 1].x;
			b = lx + (s + b) % (2 * INF + 1);
			c = (s + c) % (2 * INF + 1) - INF;
			
			up[k] = pnt(b, c);
			down[k++] = pnt(b, -c);
		} else {
			scanf("%d%d", &b, &c);
			b = (s + c + b) % k + 1;
			k -= b;
		}
		s = get_s(up, k) + get_s(down, k);
		printf("%lld\n", s);
	}
}
