/*
Date: 27.03.2012
Author: Roman Iedemskyi
Complexity: O(N + M)
Score: 100
*/
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>

#define UN(v) sort((v).begin(),(v).end()),v.erase(unique(v.begin(),v.end()),v.end())

using namespace std;

vector<int> prefix(const string & p, const string & s) {
	vector<int> pr(s.size() + 2);

	pr[0] = 0;
	for (int i = 1; i < pr.size() - 1; i++) {
		if (pr[i - 1] == p.size()) {
			pr[i] = pr[i - 1];
			continue;
		}
		pr[i] = pr[i - 1] + (s[i - 1] == p[pr[i - 1]]);
	}
	pr.back() = pr[pr.size() - 2];
	return pr;
}

int main() {
	freopen("mutation.dat", "rt", stdin);
	freopen("mutation.sol", "wt", stdout);
	vector<int> res;
	string p, s;
	cin >> p >> s;

	vector<int> pr = prefix(p, s);
	reverse(p.begin(), p.end());
	reverse(s.begin(), s.end());
	vector<int> su = prefix(p, s);
	reverse(su.begin(), su.end());
	for (int i = 0; i < pr.size() - 1; i++) 
		if (pr[i] + su[i + 1] >= p.size() - 1)
			res.push_back(pr[i]);

	UN(res);

	cout << res.size() << endl;
	for (int i = 0; i < res.size(); i++) {
		if (i) cout << " ";
		cout << res[i] + 1;
	}
	cout << endl;

	return 0;
}